/**
* blowfish.h
* this is part of semestral work to PROGRAMMING IN UNIX
* tomas.pop@seznam.cz
* this code is under Genereal public a General Public Documentation License 
*/
#ifndef BLOWFISH_H
 #define  BLOWFISH_H
 
#include "types.h" 

#define MAXKEYBYTES 	56		// 448 bits max
#define NPASS           16		// SBox passes



/**because of cbc mode of input data stream
*/
typedef struct {
	unsigned long lastL;
	unsigned long lastR;
} CBC_CTX;

/**blowfish context
*/
typedef struct{
	DWORD PArray[18];
	DWORD SBoxes[4][256];
	CBC_CTX cbc_ctx;
} BlfCtx;




void BlfInit(BlfCtx *bc, BYTE key[], int keybytes);

void BlfEncipher(BlfCtx *bc, DWORD *xl, DWORD *xr);

void BlfDecipher(BlfCtx *bc, DWORD *xl, DWORD *xr);

DWORD BlfEncode (BlfCtx *bc,BYTE * pInput, BYTE * pOutput, DWORD lSize);

void BlfDecode (BlfCtx *bc,BYTE * pInput, BYTE * pOutput, DWORD lSize);

void Blowfish_Encode_Block(BlfCtx *ctx, BYTE *block, unsigned int length);

void Blowfish_Decode_Block(BlfCtx *ctx, BYTE *block, unsigned int length);


// choose a byte order for your hardware
#ifdef linux //intel
 #define ORDER_DCBA	
#endif

#ifdef __WIN32 //intel
 #define ORDER_DCBA	
#endif

#ifdef sun //sun
 #define ORDER_ABCD	
#endif

#ifdef sgi //sgi
 #define ORDER_ABCD	
#endif

#ifdef vax //vax
 #define ORDER_BADC	
#endif

#ifdef ORDER_DCBA  	// DCBA - little endian - intel
	union aword {
	  DWORD dword;
	  BYTE byte [4];
	  struct {
	    unsigned int byte3:8;
	    unsigned int byte2:8;
	    unsigned int byte1:8;
	    unsigned int byte0:8;
	  } w;
	};
#endif

#ifdef ORDER_ABCD  	// ABCD - big endian - motorola, sun, sgi
	union aword {
	  DWORD dword;
	  BYTE byte [4];
	  struct {
	    unsigned int byte0:8;
	    unsigned int byte1:8;
	    unsigned int byte2:8;
	    unsigned int byte3:8;
	  } w;
	};
#endif

#ifdef ORDER_BADC  	// BADC - vax
	union aword {
	  DWORD dword;
	  BYTE byte [4];
	  struct {
	    unsigned int byte1:8;
	    unsigned int byte0:8;
	    unsigned int byte3:8;
	    unsigned int byte2:8;
	  } w;
};
 #endif
#endif //if !BLOWFISH_H
