/**
* client.c
* this is part of semestral work to PROGRAMMING IN UNIX
* tomas.pop@seznam.cz
* this code is under Genereal public a General Public Documentation License 
*/

#include <stdlib.h>
#include <stdio.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include <unistd.h>
#include <string.h>
#include <getopt.h>
#include <sys/stat.h>
#include <string.h>

#include "blowfish.h"
#include "md5.h"
#include "endians.h"
#include "types.h"

//for error functions
#include "common.h"

 /** store program name for messages */
  char * program_name; 

 /** flag to writing of verbose messages defalt 0, not write verbose messages */
  int verbose = 0;

 /** key to be used for blowfish decoding */
 char *key = "TESTKEY";


#ifdef linux
/** Description of long options for getopt_long.  */
  static const struct option long_options[] = {
   { "name",             1, NULL, 'n' },
   { "help",             0, NULL, 'h' },
   { "port",             1, NULL, 'p' },
   { "verbose",          0, NULL, 'v' },
   { "key",		 1, NULL, 'k' },
   { "storage",		 1, NULL, 's' },
  };
#endif

/** Description of short options for getopt_long.  */
static const char* const short_options = "n:hm:p:k:v";

/** Usage summary text.  */
static const char* const usage_template = 
  "Usage: %s [ options ]\n"
  "  -n, --name NAME           Connect to server of name NAME\n"
  "  -h, --help                Print this information.\n"
  "  -p, --port PORT           Connect to specified port PORT.\n"
  "  -v, --verbose             Print verbose messages.\n"
  "  -k, --key                 Key to use in blowfish algorithm.\n";

/** Print usage information and exit.  If IS_ERROR is non-zero, write to
    stderr and use an error exit code.  Otherwise, write to stdout and
    use a non-error termination code.  Does not return.  */

static void print_usage ()
{
  fprintf ( stdout, usage_template, program_name);
  exit (0);
}

static void client_say( const char *message){
 if (verbose){
 fprintf ( stdout , message );
 }
} 


/** transfer and decrypt the information from the server's socket.*/
int  get_file (int socket_fd, char * file, char *command)
{
  int decode_counter = 0;
  struct MD5Context md5_ctx2;
  BlfCtx bf_ctx2;
  buf buffer , buffers[4];
  ssize_t number_characters_read;
  FILE* o = stdout;
  int tmp_j, j = 0; //number of characters read
  int k =0;
  unsigned char signature[16],signature2[16],read_signature[16];
  unsigned char length_buff[sizeof(uint32)];
  char *hexfmt = "%02X";
  int comparison = 0; 
  int error = 0;
  //destination
  char *dest = strrchr(file, '/') + 1;
  


  BlfInit (&bf_ctx2, (unsigned char*)key, 7);
  MD5Init(&md5_ctx2);


  /* Send the HTTP GET command for the home page.  */
  
  sprintf (buffer, "%s %s HTTP/1.1\n", command, file);
  if (verbose)
   write(0,buffer, strlen (buffer));
  write (socket_fd, buffer, strlen (buffer));
 
  
  decode_counter = 0; 

  //first three block  read single...(this tree block should be in every-not corupted file...

  if (j = xread(socket_fd, buffer ,sizeof(buffer)) == sizeof(buffer)){
    Blowfish_Decode_Block(&bf_ctx2,  (BYTE*)&buffer, sizeof(buffer));
    MD5Update(&md5_ctx2, buffer, sizeof (buf));
    //write(0,buffer, sizeof(buffer));
  }
  else{
   client_say("file was probably corrupted, first block not long enought!!!\n");
   error = 1;
  }
  //is it message or file to be written to file?
  if (buffer[1]=='M'){
   o = stdout;  
  }
  if (buffer[1]=='F'){
   o = fopen(dest,"w");
   if (o == NULL){
    printf("could not open file for writing..write file to stdout.\n");
    o = stdout;
   }
  }


  if (j = xread(socket_fd, buffers + (decode_counter = (decode_counter + 1)  % 3),sizeof(buffer)) == sizeof(buffer)){
    Blowfish_Decode_Block(&bf_ctx2,  (BYTE*)&buffers[decode_counter],sizeof(buffer));
    //write(0,buffers[decode_counter], sizeof(buffer));
  }
  else{
   client_say("file was probably corrupted, first block not long enought!!!\n");
   error = 1;
  }

  if (j = xread(socket_fd,buffers + (decode_counter = (decode_counter + 1)  % 3),sizeof(buffer)) == sizeof(buffer)){
    Blowfish_Decode_Block(&bf_ctx2,  (BYTE*)&buffers[decode_counter],sizeof(buffer));  
    //write(0,buffers[decode_counter], sizeof(buffer));
  }
  else{
   client_say("file was probably corrupted second block not long enought!!!\n");
   error = 1;											//==sizeof(buffer)
  }

  while (j = xread(socket_fd,buffers + (decode_counter = (decode_counter + 1)  % 3),sizeof(buffer)) == sizeof(buffer)){
    Blowfish_Decode_Block(&bf_ctx2,  (BYTE*)&buffers[decode_counter],sizeof(buf));
	  MD5Update(&md5_ctx2, buffers [ (decode_counter + 1) % 3], sizeof (buf));
	  fwrite(buffers + (decode_counter + 1) % 3 ,sizeof(buffer),1, o); 
    //write(0,buffers[decode_counter], sizeof(buffer));
  }
  if (j=!1){ // EOF is on the end of file...
  client_say("file was corrupted - bad block length of last block (!=1, eof only required)");
  error = 1;
  return error;
  }

  //alalyze last buffer  containing the metainfo 
  //////////////////////////////////////////////
  //read the length of last block.
  for (j = 0; j < sizeof(uint32); j++) {
    length_buff[j] = buffers[(decode_counter+2) % 3][j];
  //printf("->%c", buffers[(decode_counter+2) % 3][j]);
  //printf("\n");  
  }
  tmp_j = get_int(length_buff);
  if (verbose)
    fprintf(stdout,"\nlast block length is: %d\n", tmp_j);
  if (tmp_j <0 ||tmp_j >sizeof(buf)){
	  client_say("bad block length readen from file...\nreturning NOW!\n");
	  error = 3;
	  return error;
	  
  }

  //read the the signature...
  for (k=0; j < (sizeof(uint32) + sizeof(read_signature)); j++,k++) {
    read_signature[k] = buffers[(decode_counter+2) % 3][j];

  }
  fwrite(buffers + (decode_counter + 1) % 3 ,tmp_j,1, o);
  client_say( "\n");
  //printf signature to the screen.. 
  client_say( "signaure of the file was /before encoding/: ");
  for(j = 0; j < sizeof read_signature; j++) {
    if (verbose)
     fprintf(stdout, hexfmt, read_signature[j]);
  }

  client_say("\n");
  MD5Update(&md5_ctx2, buffers [(decode_counter + 1) % 3], (unsigned) tmp_j);  
  //fwrite(buffers + (decode_counter + 1) % 3 ,tmp_j,1, o);

  MD5Final(signature2, &md5_ctx2);
  client_say("signaure of the file is /after decoding/:   ");
  //printf signature to the screen.. 
  for (j = 0; j < sizeof signature2; j++) {
     if (verbose)
       fprintf(stdout, hexfmt, signature2[j]);
  }
  client_say("\n");
   
  comparison = 1;
  for (j = 0; j < sizeof signature; j++) {
	  if (signature2[j]!=read_signature[j]){
		 comparison = 0;
		 break;
	  }
  }
  if (comparison){
	  client_say("        file was not corrupted.     \n");
  }
  else{
  	  printf("@@@@@@@@file was corrupted.@@@@@@@@@\n");
          error = 4;
	  return error;
  }

 if (o!= stdout)
  fclose(o);
 return error;
}


  



/** the main function of the client */
int main (int argc, char* const argv[])
{
  
  struct in_addr local_address;
  /** port to connect to default use port 5500 */
  uint16_t port = 5500;
  
  int next_option;

  /** defaultly use current folder to save all files */
  char *storage_dir ="./";

 /** socket filedescriptor */
  int socket_fd;
  
  struct sockaddr_in name;

  /**information about remote host, defaultly we connect to localhost*/
  struct hostent* hostinfo = gethostbyname ("localhost");;

  program_name = argv[0];
  /**exit status */
  int status = 0;
  /** command from stdin */
  char com[50];
  /** requested file */
  char file[100];

  
  /* Parse options.  */
  do {
      next_option = 
#ifdef linux
      getopt_long (argc, argv, short_options, long_options, NULL);
#else 
      getopt(argc,argv,"n:hp:vk:");
#endif		
    switch (next_option) {
    case 'n':  
      /* Name of the server to connect to.  */
      {
	hostinfo = gethostbyname (optarg);
      }
      break;      

    case 'h':  
      /* User specified -h or --help.  */
      print_usage ();

    case 's':
      /* User specified storage directory.*/
      {
	struct stat dir_info;

	/* Check that it exists.  */
	if (access (optarg, F_OK) != 0)
	  xerror (optarg, "module directory does not exist");
	/* Check that it is accessible.  */
	if (access (optarg, W_OK | X_OK) != 0)
	  xerror (optarg, "module directory is not accessible(can not be listed or is not writable");
	/* Make sure that it is a directory.  */
	if (stat (optarg, &dir_info) != 0 || !S_ISDIR (dir_info.st_mode))
	  xerror (optarg, "this is not a directory");
	/* It looks OK, so use it.  */
	storage_dir = strdup (optarg);
      }
      break;

    case 'p':  
      /* User specified -p or --port.  */
      {
	long value;
	char* end;

	value = strtol (optarg, &end, 10);
	if (*end != '\0')
	  /* The user specified non-digits in the port number.  */
	  print_usage (1);
	/* The port number needs to be converted to network (big endian)
           byte order.  */
	port = (uint16_t) (value);
      }
      break;
    case 'k':  
      /* User specified key to use  */
      {
	key = strdup(optarg);
      }
      break;

    case 'v':  
      /* User specified -v or --verbose.  */
      verbose = 1;
      break;

    case '?':  
      /* User specified an nrecognized option.  */
      print_usage (1);

    case -1:  
      /* Done with options.  */
      break;

    default:
      abort ();
    }
  } while (next_option != -1);

  /* This program takes no additional arguments.  Issue an error if the
     user specified any.  */
  if (optind != argc)
    print_usage (1);

  /* Create the socket.  */
  socket_fd = socket (PF_INET, SOCK_STREAM, 0);
  /* Store the server's name in the socket address.  */
  name.sin_family = AF_INET;
  /* Convert from strings to numbers.  */
  //hostinfo = gethostbyname (argv[1]);
  if (hostinfo == NULL){

    client_say("Can not find information about server...");
    print_usage();
    return 1;
  } 
  else
    name.sin_addr = *((struct in_addr *) hostinfo->h_addr);

    name.sin_port = htons (port);

  /* Connect to the server  */
 
  /* Retrieve the information from the server. */
  printf("==========sfs-client-begin==============\n");
  file[0] ='/'; file[1] = 0;
  
   printf("sfs-client>");
   scanf( "%s %s", com, file);


//main loop
///////////


 while (strcmp ((const char*)com, "quit") !=0) {

   socket_fd = socket (PF_INET, SOCK_STREAM, 0);

   if (connect (socket_fd, (const struct sockaddr*) &name, sizeof (struct sockaddr_in)) == -1) {
    perror ("connect");
    return 1;
   }
   status = get_file (socket_fd, file,"GET");
   if (status == 0)
    client_say("everything is OK\n");
   else
    printf("@@@@There were some problems via transfer, exit status is :%d @@@ ",status); 
   
   printf("sfs-client>");
   scanf(  "%s", com);
   //printf("%s\n", com);
   scanf(  "%s", file);
  }
  
  //status = get_file (socket_fd, "/","QUIT");
  printf("BYE!\n");
  printf("==========sfs-client-end==============\n");
  close(socket_fd);
  return status;
}
