/**
* common.h
* this is part of semestral work to PROGRAMMING IN UNIX
* tomas.pop@seznam.cz
* this code is under Genereal public a General Public Documentation License 
*/

#ifndef COMMON_H
 #define COMMON_H
/** Like malloc, except aborts the program if allocation fails.  
*/
extern void* xmalloc (size_t size);

/** Like realloc, except aborts the program if allocation fails.  
*/
extern void* xrealloc (void* ptr, size_t size);

/** Like strdup, except aborts the program if allocation fails.  
*/
extern char* xstrdup (const char* s);

/** reads all the data to count, not up to count like read 
* very simple and ineficinet implementation
*/
extern size_t xread(int fd, void *buf, size_t count);

/** read the data to the end-of-line. stops at oef, eol, or end of buffer. 
*/
extern size_t read_command(int fd, void *buf, size_t count);

/** Print an error message for a failed call OPERATION, using the value
   of errno, and end the program.  
*/
extern void system_error (const char* operation);

/** Print an error message for failure involving CAUSE, including a
   descriptive MESSAGE, and end the program.  
*/
extern void xerror (const char* cause, const char* message);

/** Return the directory containing the running program's executable.
   The return value is a memory buffer which the caller must deallocate
   using free.  This function calls abort on failure.  
*/
extern char* get_self_executable_directory ();

#endif
