#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include "directory.h"

void list_dir(const char *src_path, char *response, int max_response_length){
  DIR *dir;
  struct dirent *file_name;
  struct stat stat;
  char *sname = NULL;
  int number_of_char_written=1; // \n must be written
  int name_length = 0;
  int message_length = 64; //length of some error messages
  int add_end_message = 0;
  response[0] = 0; //end zero
  response = strcat(response, "\n");
  dir = opendir(src_path);
  if (dir == NULL) {
    perror(src_path);
    return;
  }
 // sname = malloc(strlen(src_path) + strlen(pan_na_holeni->d_name) + 2);	
  while ((file_name = readdir(dir)) != NULL) {
    sname = malloc(strlen(src_path) + strlen(file_name->d_name) + 2);	
    if (strcmp(file_name->d_name, ".") == 0) continue;
    if (strcmp(file_name->d_name, "..") == 0) continue;
    strcpy(sname, src_path);
    strcat(sname, file_name->d_name);
    if (lstat((const char *) sname, &stat) != 0) {
      perror(sname);
      continue;
    }
   name_length = strlen((const char *)file_name->d_name);

   if (! (max_response_length - number_of_char_written) > (name_length + message_length + 1)){
      response = strncat(response,"list is too long...\n",message_length);
      number_of_char_written += (name_length+1);
      break; 
   }

   if (S_ISREG(stat.st_mode)) {
      response = strncat(response, (const char *) file_name->d_name , name_length);
      number_of_char_written += (name_length+1);
      response = strcat(response, "\n");
    } 
    else if (S_ISDIR(stat.st_mode)) {
 	  add_end_message = 1; 	
	  continue;
        }
  }

  if (add_end_message){
      response = strncat(response,"!@@!storage contains directories, but we don support them!!@@!!\n",message_length);
      number_of_char_written += (name_length+1);
  }
  if (closedir(dir) != 0) perror(src_path);
  if (sname != NULL) free(sname);
}
/*
int main(int argc, char**argv){
 int max_length = 2048;
 char response[max_length];
 response[0] =0;
 list_dir("./storage/",response, max_length);
 printf("%s", response);
 return 1;
 
}
*/
