/**
* endians.c
* this is part of semestral work to PROGRAMMING IN UNIX
* tomas.pop@seznam.cz
* this code is under Genereal public a General Public Documentation License 
*/ 
#include "endians.h"
#include "types.h"


#ifndef HIGHFIRST
  
  void put_int(char *  buff, uint32 what){
	  
	  buff[0] = (char)(what &        0xFF);
	  buff[1] = (char)((what >>8  )& 0xFF);
	  buff[2] = (char)((what >>16 )& 0xFF);
	  buff[3] = (char)((what >>24 )& 0xFF);
  }

  uint32 get_int(char * buff){
	  uint32 toRet =0;
	  byteReverse(buff, 1);
	  toRet |= (uint32) buff[0];
	  toRet |= ((uint32)buff[1]) <<8;
	  toRet |= ((uint32)buff[2]) <<16;
	  toRet |= ((uint32)buff[3]) <<24;
	  return toRet;
  }  

#else // big endian

 void byteReverse(unsigned char *buf, unsigned longs){
     uint32 t;
     do {
	   t = (uint32) ((unsigned) buf[3] << 8 | buf[2]) << 16 |
	     ((unsigned) buf[1] << 8 | buf[0]);
	   *(uint32 *) buf = t;
	   buf += 4;
     } while (--longs);
  }


  void put_int(char *  buff, uint32 what){
	  buff[3] = (what &      0xFF);
	  buff[2] = ((what >>8  )&0xFF);
	  buff[1] = ((what >>16 )&0xFF);
	  buff[0] = ((what >>24 )&0xFF);
	  byteReverse(buff, 1);
  }
  uint32 get_int(char *  buff){
	  uint32 toRet = 0;
	  byteReverse(buff, 1);
	  toRet |= (uint32) buff[3];
	  toRet |= ((uint32)buff[2]) << 8;
	  toRet |= ((uint32)buff[1]) << 16;
	  toRet |= ((uint32)buff[0]) << 24;
	  
	  return toRet;
  }  
 
  void blowRotation(unsigned char *buf, unsigned longs){
    unsigned char tmp;
    do{
      tmp = buf[0]; buf[0] = buf[1]; buf[1] = tmp;
      tmp = buf[2]; buf[2] = buf[4]; buf[4] = tmp;
      tmp = buf[5]; buf[5] = buf[7]; buf[7] = tmp;
      buf += 8;
      } while (longs -=2);
  }
  
#endif //! HIGHTFIRST
