/**
* server.c
* this is part of semestral work to PROGRAMMING IN UNIX
* tomas.pop@seznam.cz
* this code is under Genereal public a General Public Documentation License 
*/

#include <sys/types.h>
#include <stdlib.h> 
#include <arpa/inet.h>
#include <assert.h>
#include <errno.h>
#include <netinet/in.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <fcntl.h>

#ifdef sun 
    #include <netdb.h>
    #include <unistd.h>
    #include <fcntl.h>
#endif

#ifdef sgi
 typedef __int64_t       jid_t;
#endif

#include <sys/wait.h>

//this project header files
#include "common.h"

//my own crypto files
#include "server.h"
#include "directory.h"
#include "blowfish.h"
#include "md5.h"
#include "endians.h"
#include "types.h"

extern int verbose;
extern char *storage_dir;
extern char* key;

//messages  to be written to the socket
    char* welcome_message = "Welcome on sft server!!\n";	
    char* no_subdir_message = "This server don't support subdirectories!\n";
    char* file_request_message = "You are requested a file!!\n ";   
    char* file_found_message = "----File you are requested was succesfully found on this sever----!!\n\n";
    char* file_not_found_message = "@@@-File you are requested wasn't found on this sever-@@@!!\n ";
    char* begin_message = "---this is begin of file----\n";	
    char* end_message = "\n---this is end of file----\n";	
    char* too_long_name_message = "@@this name is too long. max length is 1023 chars\n";
    char* file_name_not_ok_message = "file name must begin with \"/\"\n";
    char* bad_request_message = "bad request!!!\n ex: get /<file_name>\\n";	




/* Handler for SIGCHLD, to clean up child processes that have
   terminated.  */

/** to clean up child processes */
static void clean_up_child_process (int signal_number)

{

  int status;
  wait (&status);
}

/**function to write messages, if verbose mode, write, if not, don't) */
static void server_say(const char *message){
 if (verbose){
   printf(message);
 }
}


/** get part of message to the block from the message as a string */
size_t get_block(int* ctx, void *ptr, size_t num, char* message){
 char *reader; 
 char *writer;
 size_t num_char_read = 0;
 
 printf("ve funkci get_block\n");
 printf("%d\n", ctx);
 reader = message + (*ctx);
 printf("ve funkci get_block\n");
 writer = (char*)ptr;
 printf("ve funkci get_block\n");
 if (!message || !(*message))
 {
  return 0;

 }
  while ((*reader) && (num_char_read < num)){
  (*writer++) = (*reader++);
   num_char_read ++;
 }
 *ctx += num_char_read;
 return num_char_read;
}


/** write encoded file to the socket */
void write_file2(int  fd, int connection_fd){

BlfCtx bf_ctx;
struct MD5Context md5_ctx;
int ctx = 0;
buf buffer;
int j, tmp_j, k;
char *hexfmt = "%02X";
unsigned char signature[16],length_buff[sizeof(uint32)];
const char *mesage_header = "<FILE> ";


BlfInit (&bf_ctx, (unsigned char*) key, 7);
MD5Init(&md5_ctx);



//for (j=strlen(mesage_header;j<sizeof(buffer);j++);

strcpy(buffer,mesage_header);
for (j = strlen(mesage_header);j<sizeof(buffer);j++){
 buffer[j] = 'x';
 //padding.
}
MD5Update(&md5_ctx, buffer, (unsigned) j);
Blowfish_Encode_Block(&bf_ctx, (BYTE*)&buffer ,sizeof(buffer));
write(connection_fd, buffer,j);



   while ((j = xread(fd,buffer,sizeof(buf)) ) == sizeof(buf) ){
	     //printf("OK,readen");
	     MD5Update(&md5_ctx, buffer, (unsigned) j);
       Blowfish_Encode_Block(&bf_ctx, (BYTE*)&buffer ,sizeof(buffer));
 	     write(connection_fd, buffer,j);
	     //write(0, buffer,j);
	   } 

	//encoding finalization
	////////////////////////	
	    if (verbose) printf("last line length %d!!!\n", j);
  		MD5Update(&md5_ctx, buffer, (unsigned) j);
  		tmp_j = j;
  		MD5Final(signature, &md5_ctx);
  		//the hash is complete...
  		for(;j<sizeof(buffer); j++){
   			buffer[j] ='x'; //just a padding;
  		}
  		Blowfish_Encode_Block(&bf_ctx, (BYTE*)&buffer ,sizeof(buffer));
  		write(connection_fd, buffer,j); 
  
	  	j=0;
  		put_int(length_buff, tmp_j);
 		//write length of last block with real data;  
  		for (j = 0; j < sizeof(uint32); j++) {
    			buffer[j] = length_buff[j];
		//	printf("%c", length_buff[j]);
  		}
  
 		//write hash to file 
  		for (k=0; j < (sizeof(uint32) + sizeof(signature)); j++,k++) {
    			buffer[j] = signature[k];
  		}
 		//write padding to the end of the file
  		for (;j<sizeof(buffer);j++)
	  	buffer[j]='x'; //padding
 
  		Blowfish_Encode_Block(&bf_ctx,  (BYTE*)&buffer ,sizeof(buffer));
  		write(connection_fd, buffer,j);
	     for (j = 0; j < sizeof signature; j++) {
              fprintf(stdout, hexfmt, signature[j]);
             }
 	     fprintf(stdout,"\n");
	   close(fd);
	  if (verbose) printf("file succesfully written to socket.\n");
	 
}


/** write encoded message to the socket */
void write_message(char *response, int connection_fd){

BlfCtx bf_ctx;
struct MD5Context md5_ctx;
int ctx = 0;
buf buffer;
int j, tmp_j, k;
char *hexfmt = "%02X";
unsigned char signature[16],length_buff[sizeof(uint32)];
const char *mesage_header = "<MESS> ";


BlfInit (&bf_ctx, (unsigned char*) key, 7);
MD5Init(&md5_ctx);

strcpy(buffer,mesage_header);
for (j=strlen(mesage_header);j < sizeof(buffer);j++){
 buffer[j] = 'x';
 //padding.
}
MD5Update(&md5_ctx, buffer, (unsigned) j);
Blowfish_Encode_Block(&bf_ctx, (BYTE*)&buffer ,sizeof(buffer));
write(connection_fd, buffer,j);
//write(0, buffer,j);
//for (j = 0; j<sizeof(buffer); j++){
// printf(" %d -> %c", j,buffer[j]);
//}

 while ( (j = get_block(&ctx, buffer, sizeof(buffer), response) ) == sizeof(buffer) ){
	     MD5Update(&md5_ctx, buffer, (unsigned) j);
       Blowfish_Encode_Block(&bf_ctx, (BYTE*)&buffer ,sizeof(buffer));
 	     write(connection_fd, buffer,j);
	     //write(0, buffer,j);
	     // for (j = 0; j<sizeof(buffer); j++){
       //   printf(" %d -> %c", j,buffer[j]);
       //}

	   }


        printf("last line length %d!!!\n", j);
  		MD5Update(&md5_ctx, buffer, (unsigned) j);
  		tmp_j = j;
  		MD5Final(signature, &md5_ctx);
  		//the hash is complete...
  		for(;j<sizeof(buffer); j++){
   			buffer[j] ='x'; //just a padding;
  		}
  		Blowfish_Encode_Block(&bf_ctx, (BYTE*)&buffer ,sizeof(buffer));
  		write(connection_fd, buffer,j); 
  
	  	j=0;
  		put_int(length_buff, tmp_j);
 		//write length of last block with real data;  
  		for (j = 0; j < sizeof(uint32); j++) {
    			buffer[j] = length_buff[j];
		//	printf("%c", length_buff[j]);
  		}
  
 		//write hash to file 
  		for (k=0; j < (sizeof(uint32) + sizeof(signature)); j++,k++) {
    			buffer[j] = signature[k];
  		}
 		//write padding to the end of the file
  		for (;j<sizeof(buffer);j++)
	  	buffer[j]='x'; //padding
 
  		Blowfish_Encode_Block(&bf_ctx, (BYTE*)&buffer ,sizeof(buffer));
  		write(connection_fd, buffer,j);
	   	//printf("konec vypisu souboru do spojeni...\n");
           //write(connection_fd, end_message, strlen (end_message));
	     for (j = 0; j < sizeof signature; j++) {
              fprintf(stdout, hexfmt, signature[j]);
             }
 	     fprintf(stdout,"\n");


         printf("file written!\n");
 

}




/**
* this function get request for some page and handle it that means encode it, and send it in file descriptor
* conection_fd
* page is file or some message, like list of available files, or message, that file was not found.
*
*/
static void handle_get (int connection_fd, const char* page)
{
  char  file_name[1024] ;
 printf("jsme v handle_get\n");

  //these variables are here for file encoding

 
  buf buffer , buffers[4]; // buffers are for encoding.
 
  if (*page == '/'){
    int max_response_length = 2048;
    int max_filename_length = 1024;
    int j;	
    char response[max_response_length];
    char filename[max_filename_length];
    const char *  filename1;
    //FILE *fd;
    int fd;
    char requested_file_name[1024]; 

  if (strlen(page) == 1){
     //this is request for the index...
     response[0] = 0;
     list_dir(storage_dir,response, max_response_length); 
     //so write list of dir to the socket
     write_message(response,connection_fd);
    }
    else{
    //somebody is trying to get some file

    if (strchr(page + 1, '/') == NULL){
    //we dont suppeort subdirectories
    //so this request is OK.
	filename1 = page + 1;
        //write(connection_fd, file_request_message, strlen (file_request_message));
	if (strlen(filename1) > 1023) {
	  write_message (too_long_name_message,connection_fd);
	}
	else{ 
	 snprintf(filename,sizeof(filename),"./storage/%s",filename1);
         //fd = fopen(filename,"r");
	 //if ( fd != NULL ) {
         fd = open(filename,O_RDONLY);
	 if ( fd != -1 ) {

 	  server_say("begining to write file to the socket: filename :");
	  server_say(page);
	  server_say("\n");

	 write_file2(fd, connection_fd );
        }
	else{
	 write_message ( file_not_found_message,connection_fd);
 	 server_say("somebody is trying to get some file but file dont't exists or unreadable!!: filename :");
	 server_say(page);
	 server_say("\n");

	}
       }
    }
    else{
         /* somebody is trying to get something from subdirectories */
         write (connection_fd, no_subdir_message, strlen (no_subdir_message));
 	 server_say("somebody is trying to get some file from subdirectory!!: filename :");
	 server_say(page);
	 server_say("\n");
         write_message(no_subdir_message ,connection_fd); 
    }
   }

  }
  else{
   write_message(file_name_not_ok_message ,connection_fd); 
  }

 
}

/** Handle a client connection on the file descriptor CONNECTION_FD.  */
static void handle_connection (int connection_fd)
{
  char buffer[256];
  ssize_t bytes_read;
  char method[sizeof (buffer)];
  char url[sizeof (buffer)];
  char protocol[sizeof (buffer)];

  int end = 0;

  /* Read first line from client.  */
 //while (!end)
 {
  bytes_read = read_command (connection_fd, buffer, sizeof (buffer) - 1);
  if (bytes_read > 0) {
   
    /* Some data was read successfully.  NUL-terminate the buffer so
       we can use string operations on it.  */
    buffer[bytes_read] = '\0';
    /* The first line the client sends is the HTTP request, which is
       composed of a method, the requested page, and the protocol
       version.  */
    printf("%s\n", buffer);
    sscanf (buffer, "%s %s %s", method, url, protocol);
    printf("protocolo is: %s\n",protocol);
    printf("method is: %s\n",method);
    printf("page is: %s\n",url);
 
 /*   while (strstr (buffer, "\r\n\r\n") == NULL)
      bytes_read = read (connection_fd, buffer, sizeof (buffer));
      Make sure the last read didn't fail.  If it did, there's a
       problem with the connection, so give up.  */
    if (bytes_read == -1) {
      close (connection_fd);
      return;
    }

    /* Check the protocol field.  We understand HTTP versions 1.0 and
       1.1.  */
    if (strcmp (protocol, "HTTP/1.0") && strcmp (protocol, "HTTP/1.1")) {
      /* We don't understand this protocol.  Report a bad response.  */
      write_message(bad_request_message,  connection_fd);
      //write (connection_fd, bad_request_response, sizeof (bad_request_response));
      server_say("bad protocol");
    }
    else
    if (strcmp (method, "GET")) {
      /* This server only implements the GET method.  The client
	 specified some other method, so report the failure.  */
      //char response[1024];
    if (strcmp (method, "QUIT")) {
      end = 1;
      return;
    }
   
      server_say("bad method");

      //snprintf (response, sizeof (response),bad_method_response_template, method);
      write_message (bad_request_message,connection_fd);

    }
    else 
      /* A valid request.  Process it.  */
      {
	printf("handle ok\n");
        handle_get (connection_fd, url);
	
      }
  }
  else if (bytes_read == 0)
    /* The client closed the connection before sending any data.
       Nothing to do.  */
    ;
  else 
    /* The call to read failed.  */
    system_error ("read");
 }
}


void server_run (struct in_addr local_address, uint16_t port, char *program_name)
{
  struct sockaddr_in socket_address;
  int rval;
  struct sigaction sigchld_action;
  int server_socket;

  /* Install a handler for SIGCHLD that cleans up child processes that
     have terminated.  */
  memset (&sigchld_action, 0, sizeof (sigchld_action));
  sigchld_action.sa_handler = &clean_up_child_process;
  sigaction (SIGCHLD, &sigchld_action, NULL);

  /* Create a TCP socket.  */
  server_socket = socket (PF_INET, SOCK_STREAM, 0);
  if (server_socket == -1)
    system_error ("socket");
  /* Construct a socket address structure for the local address on
     which we want to listen for connections.  */
  memset (&socket_address, 0, sizeof (socket_address));
  socket_address.sin_family = AF_INET;
  socket_address.sin_port = port;
  socket_address.sin_addr = local_address;
  /* Bind the socket to that address.  */
  rval = bind(server_socket, (const struct sockaddr*) &socket_address, sizeof (socket_address));
  if (rval != 0)
    system_error ("bind");
  /*  Instruct the socket to accept connections.  */
  rval = listen (server_socket, 10);
  if (rval != 0)
    system_error ("listen");

  if (verbose) {
    /* In verbose mode, display the local address and port number
       we're listening on.  */
    socklen_t address_length;
    
    /* Find the socket's local address.  */
    address_length = sizeof (socket_address);
    rval = getsockname (server_socket, (struct sockaddr*) &socket_address, &address_length);
    assert (rval == 0);
    /* Print a message.  The port number needs to be converted from
       network byte order (big endian) to host byte order.  */
    printf ("server running at %s:\n",program_name);
    printf ("server listening on %s:%d\n", 
	    inet_ntoa (socket_address.sin_addr), 
	    (int) ntohs (socket_address.sin_port));
  }

  /* Loop forever, handling connections.  */
  while (1) {
    struct sockaddr_in remote_address;
    socklen_t address_length;
    int connection;
    pid_t child_pid;

    /* Accept a connection.  This call blocks until a connection is
       ready.  */
    address_length = sizeof (remote_address);
    connection = accept (server_socket, (struct sockaddr*)&remote_address, &address_length);
    if (connection == -1) {
      /* The call to accept failed.  */
      if (errno == EINTR)
	/* The call was interrupted by a signal.  Try again.  */
	continue;
      else
	/* Something else went wrong.  */
	system_error ("accept");
    }

    /* We have a connection.  Print a message if we're running in
       verbose mode.  */
    if (verbose) {
      socklen_t address_length;

      /* Get the remote address of the connection.  */
      address_length = sizeof (socket_address);
      rval = getpeername (connection, (struct sockaddr*) &socket_address, &address_length);
      assert (rval == 0);
      /* Print a message.  */
      printf ("connection accepted from %s\n",
	      inet_ntoa (socket_address.sin_addr));
    }

    /* Fork a child process to handle the connection.  */
    child_pid = fork ();
    if (child_pid == 0) {
     close (server_socket);
      /* Handle a request from the connection.  We have our own copy
	 of the connected socket descriptor.  */
      handle_connection (connection);
      /* All done; close the connection socket, and end the child
	 process.  */
      close (connection);
      exit (0);
    }
    else if (child_pid > 0) {
      /* This is the parent process.  The child process handles the
	 connection, so we don't need our copy of the connected socket
	 descriptor.  Close it.  Then continue with the loop and
	 accept another connection.  */
      close (connection);
    }
    else
      /* Call to fork failed.  */
      system_error ("fork");
  }
}
