/**
* server.h
* this is part of semestral work to PROGRAMMING IN UNIX
* tomas.pop@seznam.cz
* this code is under Genereal public a General Public Documentation License 
*/

#ifndef SERVER_H
 #define SERVER_H

#include <netinet/in.h>
#include <sys/types.h>

/*** Symbols defined in common.c.  ************************************/

/** The name of this program.  */
extern const char* program_name;

/** If non-zero, print verbose messages.  */
extern int verbose;

/** Like malloc, except aborts the program if allocation fails.  */
extern void* xmalloc (size_t size);

/** Like realloc, except aborts the program if allocation fails.  */
extern void* xrealloc (void* ptr, size_t size);

/** Like strdup, except aborts the program if allocation fails.  */
extern char* xstrdup (const char* s);

/** Print an error message for a failed call OPERATION, using the value
   of errno, and end the program.  */
extern void system_error (const char* operation);

/** Print an error message for failure involving CAUSE, including a
   descriptive MESSAGE, and end the program.  */
extern void xerror (const char* cause, const char* message);

/** Return the directory containing the running program's executable.
   The return value is a memory buffer which the caller must deallocate
   using free.  This function calls abort on failure.  */
extern char* get_self_executable_directory ();



/*** symbols defined in main.c */

/** The directory from which modules are loaded.  */
extern char* storage_dir;


/** Run the server on LOCAL_ADDRESS and PORT.  
*/
extern void server_run (struct in_addr local_address, uint16_t port, char* program_name);


#endif  /* ! SERVER_H */
